<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form id="formId" v-show="searchOpen" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" @on-enter="_formSearch" name="client" placeholder="请输入委托单位" clearable/>
              </Form-item>
              <Form-item class="search-item" label="委托编号:">
                <Input v-model="formObj.entrustCode" @on-enter="_formSearch" name="entrustCode" placeholder="请输入委托编号" clearable/>
              </Form-item>
              <Form-item class="search-btn">
                <Button @click="_formSearch" type="primary">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" @on-result-change="_btnClick"
                      class="contHide"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg"  @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                   <span v-if="item.key==='edate'">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}
                  </span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <MeterSampleManage ref="meterSampleManageModal"  @on-result-change="_page"></MeterSampleManage>
    <MeterEntrustDetail ref="meterSampleEdit" @on-result-change="_page"></MeterEntrustDetail>
    <FileManage ref="FileManage" @on-result-change="_page"></FileManage>
    <MeterEntrustRecord ref="meterEntrustRecordModal" @on-result-change="_page"></MeterEntrustRecord>
  </div>
</template>
<script>
import { meterEntrust, meterSubcontractor } from '../../../api'
import MeterEntrustRecord from '../../../components/operation/Operation'
import http from '../../../api/http'
import MeterSampleManage from './MeterSampleReceiveHis'
import MeterEntrustDetail from './MeterEntrustDetail'
export default {
  components: { MeterSampleManage, MeterEntrustDetail, MeterEntrustRecord },
  data() {
    return {
      currentComponent: 'FoodSampleGovern',
      formId: 'meterReviewEntrustFormId',
      searchOpen: true,
      btn: [
        {
          type: 'success',
          id: 'meter-receive-entrust-his-register-btn',
          name: '样品交接发放登记表'
        }
      ],
      iconMsg: [
        {
          type: 'md-paper',
          id: 'meter-receive-entrust-his-detail',
          name: '详情'
        },
        {
          type: 'ios-beaker',
          id: 'meter-receive-entrust-his-sample-manage',
          name: '样品管理'
        },
        {
          type: 'md-cloud',
          id: 'meter-receive-entrust-his-accessory',
          name: '附件'
        },
        {
          type: 'ios-clock',
          id: 'meter-receive-entrust-his-record',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        entrustCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '委托编号', key: 'entrustCode', width: 130 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '邮编', key: 'postcode' },
        { title: 'E-mail', key: 'email', width: 120 },
        { title: '委托日期', key: 'edate', width: 120 },
        { title: '费用合计', key: 'fee', width: 120 },
        { title: '合同号', key: 'contractCode', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _detailModal(data) {
      console.log(data)
      this.$refs.meterSampleEdit._open(data)
    },
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case '通过':
            this._passReview()
            break
          case '样品交接发放登记表':
            this._exportSampleHis()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },
    _iconClick(res, data) {
      this.$nextTick(function() {
        switch (res) {
          case '样品管理':
            this._manageSample(data.id)
            break
          case '详情':
            this._detailModal(data)
            break
          case '编辑':
            this._editModal(true, data.id)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
        }
      })
    },
    _manageSample(data) {
      // 管理样品
      this.$refs.meterSampleManageModal._open(data)
    },
    _componentResult(data, msg) {
      switch (this.currentComponent) {
        case 'FoodContractCompanyEdit':
          this._page()
          break
        case 'FoodContractGovernEdit':
          this._page()
          break
        case 'FoodContractCompanyEditByDLTB':
          this._page()
          break
        case 'FoodContractCompanyEditByHES':
          this._page()
          break
      }
    },
    _record(id) {
      this.$refs.meterEntrustRecordModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData)
          break
        case 'changeSize':
          this._page()
          break
        case 'selectIds':
          this.selectIds = data
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      const result = await meterEntrust.pageEntrustReceiveHis(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },

    _passReview() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要通过评审的委托单！')
        return false
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定通过该委托单？',
        onOk: () => {
          this._passEntrustReview(this.selectIds)
        }
      })
    },

    _exportSampleHis() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要导出的委托单！')
        return false
      }
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出样品交接发放登记表？',
        onOk: () => {
          this._exportSampleSendReceive(this.selectIds)
        }
      })
    },
    _exportSampleSendReceive(data) {
      http.open(
        '/meter/v1/sample/export_sample_receive_send/?entrustIds=' + data
      )
    },
    _passEntrustReview: async function(ids) {
      const result = await meterEntrust.passReview(ids)
      if (result) {
        this.$Message.success('提交成功！')
        await this._page()
      }
    },

    // 追加项目
    _itemModal(data) {
      this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSubcontractor.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._open(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSubcontractor.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
